(function() {
	
	$.provide("$.Renderers");
	
	var Product = $.Renderers.ProductRenderer = function( options ) {
		
		this.da = {};
		
		this.settings = {
			media: {
				images:			[],
				mediaMaxWidth:	0,
				mediaMaxHeight:	0
			},
			plFrameParent:		{ css: "", className: "pl-frame-parent" },
			plImg:				{ css: "", className: "pl-img" },
			plDatasheet:		{ css: "", className: "pl-datasheet smaller quiet" },
			plInfosheet:		{ css: "", className: "pl-infosheet" },
			plDesc:				{ css: "", className: "pl-desc" },
			plName:				{ css: "", className: "pl-name" },
			plSales:			{ css: "", className: "pl-sales" },
			layout:				"grid"
		};
		
		this.options = {
			//datasheet
			showID:					false,
			showEAN: 				false,
			showWeight:				false,
			showManufact:			false,
			showDeliveryTime:		false,
			showDeliveryTimeText:	false,
			
			//pricing
			showPrice:				true, 			//toBool(xel.getAttribute("show-item-price"), true)
			showPricePrefix:		true, 			//toBool(xel.getAttribute("show-item-price-prefix"), true)
			showPriceSuffix:		true,			//toBool(xel.getAttribute("show-item-price-suffix"), true)
			showDifference:			false,			//toBool(xel.getAttribute("show-item-difference"), false)
			showPriceBase:			false,			//toBool(xel.getAttribute("show-item-price-base"), false)
			showVATInfos:			true,			//toBool(api.getProjectSetting("show-vat-infos"), true)
			showDiscountIndicator:	true,
			
			showSecCur:				false,
			displayGrossPrice:		true,
			defaultWeightUnit: 		"",
			
			//discounts
			hasDefaultDiscount:		false,			// plSettings.plItemDefDiscount
			defaultDiscountType:	0,				// plSettings.plItemDefDiscType
			itemDiscData:			"",				// plSettings.plItemDiscData
			
			showAddToBag:			true,			// toBool(xel.getAttribute("show-addtobag"), true)
			showMore:				true,			// toBool(xel.getAttribute("show-item-more-link"), true)
			showQtyInput:			true,			// toBool(xel.getAttribute("show-qty-input"), false)
			showQtyUnit:			false,			// toBool(xel.getAttribute("show-qty-unit"), false)
			
			showItemImages:			true, 			//toBool(xel.getAttribute("show-item-image"), true)
			isPicture:				true,			//toStr(xel.getAttribute("item-image-style"), "thumb") == "picture")
			showNoPic: 				true,			//toBool(xel.getAttribute("item-image-show-nopic"), true)
			linkItemImages:			true,			//toBool(xel.getAttribute("link-item-images"), true)
			showVariants:			false,			//toBool(xel.getAttribute("show-item-variants"), false)
			showItemPartsList:		true, 			//toBool(xel.getAttribute("show-item-partslist"), true)
			navBarPos:				"bottom",		//toStr(xel.getAttribute("navbar-position"), "bottom")
			navbarAlign:			"right",		//toStr(xel.getAttribute("navbar-align"), "right")
			maxItems:				0,				//toInt(xel.getAttribute("max-items-per-page"), 0)
			descMaxLength: 			255,			//toInt(xel.getAttribute("item-description-maxlength"), 0)
			
			displayTitlesOnTop:		false,			//toBool(xel.getAttribute("display-titles-ontop"), false)
			isTitleLinked:	 		true,			//toBool(xel.getAttribute("link-item-titles"), true)
			displayLargeTitles: 	false,			//toBool(xel.getAttribute("large-item-titles"), false)
			itemImageAlign: 		"center",		//toStr(xel.getAttribute("item-image-align"), "left") 
			showName: 				true,			//toBool(xel.getAttribute("show-item-name"), true)
			showItemDesc: 			true,			//toBool(xel.getAttribute("show-item-description"), true)
			buttonAlign:			"far",			//toStr(xel.getAttribute("buttons-align"), "far")
			
			colCount: 				3,				//toInt(xel.getAttribute("columns-count"), 3)
			currentPage:			1,
			
			alignElemsToGrid:		true,			//toBool(xel.getAttribute("align-elements-to-grid"), true)
			alignElemsPerRow:		false,			//toBool(xel.getAttribute("align-elements-per-row"), false)
			
			maxImageWidth:			0,
			maxImageHeight:			0
		};
		
		if (options) this.options = $.extend( this.options, options );
	
	}
	
	// converts xml markup to option object that can be passed to the initialiser
	Product.convertOptions = function( xelModule ) {
		
		var opts = { }, s = "", l = 0, b = false;
		
		//datasheet
		if ( !!(b = toBool(xelModule.getAttribute("show-item-id"))) ) // ps: false 
			opts.showID = b;
		if ( !!(b = toBool(xelModule.getAttribute("show-item-ean"))) ) 
			opts.showEAN = b;
		if ( !!(b = toBool(xelModule.getAttribute("show-item-weight"))) ) 
			opts.showWeight = b;
		if ( !!(b = toBool(xelModule.getAttribute("show-item-manufacturer"))) ) 
			opts.showManufact = b;
		if ( !!(b = toBool(xelModule.getAttribute("show-item-delivery-time"))) ) 
			opts.showDeliveryTime = b;
		if ( !!(b = toBool(xelModule.getAttribute("show-item-delivery-time-text"))) ) 
			opts.showDeliveryTimeText = b;
		
		//pricing
		opts.showPrice = toBool(xelModule.getAttribute("show-item-price"), true);
		opts.showPricePrefix = toBool(xelModule.getAttribute("show-item-price-prefix"), true); // ps: true
		opts.showPriceSuffix = toBool(xelModule.getAttribute("show-item-price-suffix"), true); // ps: true
		opts.showVATInfos = toBool(xelModule.getAttribute("show-vat-infos"), true);
		opts.showDiscountIndicator = toBool(xelModule.getAttribute("show-discount-indicator"), true);
		opts.showAddToBag = toBool(xelModule.getAttribute("show-addtobag"), true);
		opts.showMore = toBool(xelModule.getAttribute("show-item-more-link"), true); // ps: false
		opts.showQtyInput = toBool(xelModule.getAttribute("show-qty-input"), true);
		
		if ( !!(b = toBool(xelModule.getAttribute("show-item-difference"))) ) // ps: true
			opts.showDifference = b;
		if ( !!(b = toBool(xelModule.getAttribute("show-item-price-base"))) ) 
			opts.showPriceBase = b;
		if ( !!(b = toBool(xelModule.getAttribute("show-qty-unit"))) ) 
			opts.showQtyUnit = b;
		
		//misc
		opts.showItemImages = toBool(xelModule.getAttribute("show-item-image"), true);
		opts.showNoPic = toBool(xelModule.getAttribute("item-image-show-nopic"), true); // ps: true
		opts.linkItemImages = toBool(xelModule.getAttribute("link-item-images"), true); // ps: true
		opts.showItemPartsList = toBool(xelModule.getAttribute("show-item-partslist"), true); // ps: false
		opts.isTitleLinked = toBool(xelModule.getAttribute("link-item-titles"), true); // ps: true
		opts.alignElemsToGrid = toBool(xel.getAttribute("align-elements-to-grid"), true); // ps: NEU
		opts.alignElemsPerRow = toBool(xel.getAttribute("align-elements-per-row"), false); // ps: NEU
		opts.showName = toBool(xelModule.getAttribute("show-item-name"), true);
		opts.showItemDesc = toBool(xelModule.getAttribute("show-item-description"), true);
		opts.forceGrid = toBool(xelModule.getAttribute("display-grid"), false);
		
		if ( !!(s = toStr(xelModule.getAttribute("item-image-style"))) )  // ps: Nada
			opts.pictureType = s;
		if ( !!(b = toBool(xelModule.getAttribute("show-item-variants"))) )  // ps: true
			opts.showVariants = b;
		if ( !!(s = toStr(xelModule.getAttribute("navbar-position"))) ) // ps: NEU
			opts.navBarPos = s;
		if ( !!(s = toStr(xelModule.getAttribute("navbar-align"))) ) // ps: NEU
			opts.navbarAlign = s;
		if ( !!(s = toStr(xelModule.getAttribute("list-intro-text"))) )
			opts.introText = s;
		if ( !!(l = toInt(xelModule.getAttribute("max-items-per-page"))) ) 
			opts.maxItems = l;
		if ( !!(s = toStr(xelModule.getAttribute("list-footer-text"))) ) 
			opts.footerText = s;
		if ( !!(l = toInt(xelModule.getAttribute("item-description-maxlength"))) ) // ps: NEU
			opts.descMaxLength = l;
		if ( !!(b = toBool(xelModule.getAttribute("display-titles-ontop"))) ) // ps: show-title-ontop
			opts.displayTitlesOnTop = b;
		if ( !!(b = toBool(xelModule.getAttribute("large-item-titles"))) ) // ps: item-large-title
			opts.displayLargeTitles = b;
		if ( !!(s = toStr(xelModule.getAttribute("item-image-align"))) ) 
			opts.itemImageAlign = s;
		if ( !!(s = toStr(xelModule.getAttribute("buttons-align"))) ) 
			opts.buttonAlign = s;
		if ( !!(l = toInt(xelModule.getAttribute("columns-count"))) ) 
			opts.colCount = l;
		if ( !!(l = toInt(xelModule.getAttribute("current-page"))) ) 
			opts.currentPage = l;
		if ( !!(l = toInt(xelModule.getAttribute("max-image-width"))) ) 
			opts.maxImageWidth = l;
		if ( !!(l = toInt(xelModule.getAttribute("max-image-height"))) ) 
			opts.maxImageHeight = l;
		
		return opts;
	}
	
	Product.fn = Product.prototype = {
		
		// builds complete product / content of article.pl-element
		getHtml: function( da ) {
			
			var htmlCode = "",
				opts = this.options,
				settings = this.settings;
			
			this.da = da;
			
			// gets script block to initialise the product
			htmlCode += this.getProductJSInitCode();
			this.getDiscounts();
			
			// build html
			if (opts.showName && opts.displayTitlesOnTop) {
				htmlCode += this.getName( da.val('NAME'), opts.isTitleLinked );
			}
			
			if (opts.showItemImages)
				htmlCode += this.getMediaItem(da.val('NAME'));
			
			htmlCode += '<div class="{0}" style="{1}">'.format( settings.plInfosheet.className, settings.plInfosheet.css );
			
			if(opts.showName && !opts.displayTitlesOnTop)
				htmlCode += this.getName( da.val('NAME'), opts.isTitleLinked );
			
			htmlCode += this.getDesc();
			
			//if (opts.colCount == 1){
			if (!settings.isGrid){
				htmlCode += this.getPartsList( false, false );
				htmlCode += this.getPriceBlock(false);
				htmlCode += this.getDataSheet();
			} else {
				htmlCode += this.getDataSheet();
				htmlCode += this.getPartsList( true, false );
				htmlCode += this.getPriceBlock(true);
			}
			
			htmlCode += this.getDiscountSign(true);
			htmlCode += this.getNeuesBild(true);
			htmlCode += '</div>';
			
			return htmlCode;
		},
		
		init: function(da){
			
			var opts = this.options,
				settings = this.settings,
				tempWidth, tempHeight;
			
			opts.isThumb = (opts.pictureType == "thumb") ? false : true;
			settings.isGrid = (opts.colCount != 1) || opts.forceGrid ? true : false;
			
			// BEGIN: get media dimensions
			if (opts.itemImageAlign !== 'none') {
				if (!da.eof()) da.moveFirst();
				while (!da.eof()) {
					if(da.absolutePage() < opts.currentPage) { 
						da.moveNext(); 
						continue; 
					} 
					else if(da.absolutePage() > opts.currentPage) {
						break;
					}
					
					// main picture/thumb
					var mediaPkid = opts.isThumb ? da.val("PICTUREMREF") : da.val("THUMBMREF"),
						mObj = mediaPkid == 0 ? null : this.getMediaData(mediaPkid);
					
					if(!mObj){
						// base category picture/thumb
						mediaPkid = opts.isThumb ? da.val('BASECATEGORYDEFAULTTHUMBMREF') : da.val('BASECATEGORYDEFAULTPICTUREMREF');
						//mObj = mediaPkid == 0 ? null : this.getMediaData(mediaPkid);
						mObj = toStr(mediaPkid) == "" ? null : this.getMediaData(mediaPkid);
					}
					
					if(!mObj && opts.showNoPic) {
						// no pic picture/thumb 
						mediaPkid = opts.isThumb ? "img_nopic_large" : "img_nopic_small";
						mObj = this.getMediaData(mediaPkid, true);
					} else if (!mObj && !opts.showNoPic) {
						mediaPkid = "spacer";
						mObj = this.getMediaData(mediaPkid, true);
					}
					
					settings.media.images[da.val("PKID")] = mObj;
					// max width / max height
					if(mObj){
						tempWidth = (opts.maxImageWidth == 0) ? mObj.width : Math.min(mObj.width, opts.maxImageWidth);
						tempHeight = (opts.maxImageHeight == 0) ? mObj.height : Math.min(mObj.height, opts.maxImageHeight);
						settings.media.mediaMaxWidth = Math.max( settings.media.mediaMaxWidth, tempWidth );
						settings.media.mediaMaxHeight = Math.max( settings.media.mediaMaxHeight, tempHeight );
					}
					da.moveNext();
				}
				
				if(!da.bof()) 
					da.moveFirst();
			}
			// END: get media dimensions
			
			if(opts.displayTitlesOnTop)
				settings.plName.css += "margin-bottom: {0}px;".format( $.Grid.marginRight );
			
			//if(opts.colCount == 1){
			if(!settings.isGrid){
				// 
				settings.plFrameParent.css += "width: {0}px;height: {1}px;margin-right: {2}px;".format( 
					settings.media.mediaMaxWidth, 
					settings.media.mediaMaxHeight,
					$.Grid.marginLeft + $.Grid.marginRight );
			} else {
				//
				settings.plFrameParent.css += "height: {0}px;".format( settings.media.mediaMaxHeight );
				
				// align images horizontal
				switch(opts.itemImageAlign){
					case "near":
						settings.plFrameParent.className += " al";
						break;
					case "center":
						settings.plFrameParent.className += " ac";
						break;
					case "far":
						settings.plFrameParent.className += " ar";
						break;
					case 'none':
						settings.plFrameParent.className += ' d-n';
						break;
				}
			}
			
			//set max-width or max-height when not 0
			if( (opts.maxImageWidth != 0) || (opts.maxImageHeight != 0) ){
				if(opts.maxImageWidth != 0){
					settings.plImg.css += "max-width:{0}px;height:auto !important;".format( opts.maxImageWidth );
				}
				if(opts.maxImageHeight != 0){
					settings.plImg.css += "max-height:{0}px;width:auto !important;".format(opts.maxImageHeight);
				}
			}
			
			if (opts.displayLargeTitles){
				//settings.plName.className += (opts.colCount == 1) ? " x-larger" : " larger";
				settings.plName.className += (!settings.isGrid) ? " x-larger" : " larger";
			} else {
				//settings.plName.className += (opts.colCount == 1) ? " larger" : "";
				settings.plName.className += (!settings.isGrid) ? " larger" : "";
			}
		},
		
		getName: function( name, isLinked ) {
			
			var settings = this.settings;
			
			//if(this.options.colCount != 1)
			if(settings.isGrid)
				name = _.truncate( toStr(name), 70, "..." );
			
			var link = '<a href="{0}" target="{1}">{2}</a>'.format( this.getItemHref(), this.getItemTarget(), name );
			
			return '<h4 class="{0}" style="{1}">{2}</h4>'.format( 
				settings.plName.className, 
				settings.plName.css, 
				isLinked ? link : name );
		},
		
		getDesc: function() {
			
			var da = this.da,
				htmlCode = "",
				opts = this.options,
				settings = this.settings;
			
			htmlCode += '<div class="{0}" style="{1}">'.format( settings.plDesc.className, settings.plDesc.css );
			if(opts.showItemDesc && toStr(da.val('DESCRIPTION')).length > 0){
				htmlCode += _.truncate( toStr( da.val("DESCRIPTION") ), opts.descMaxLength, "..." );
			}
			htmlCode += '</div>';
			
			return htmlCode;
		},
		
		// gets javascript code to asign discounts to the product
		getDiscounts: function(){
			
			var da = this.da,
				lPkid = da.val("PKID"),
				opts = this.options;
			
			opts.hasDefaultDiscount = false;
			opts.defaultDiscountType = 0;
			opts.itemDiscData = "";

			if( toBool( da.val("HASDISCOUNTS"), false) ) {
				
				var rs = api.products.serializedQuantityDiscounts( lPkid , false );
				if( rs != null ){
					rs.moveFirst();
					while( !rs.eof ){
						if(parseInt(rs("FROMAMOUNT")) <= parseInt( da.val("MINORDERQTY"))){
							opts.itemDiscData += 'SMProduct.discounts.add({0}, {1}, {2}, "{3}");'.format( rs("FROMAMOUNT"), rs("DISCOUNTTYPE"), rs("DISCOUNTVALUE"), toStr(rs("NAME")));
							opts.hasDefaultDiscount = true;
							opts.defaultDiscountType = parseInt(rs("DISCOUNTTYPE"));
						}
						rs.moveNext();
					}
					rs.close();
					rs = opts.itemDiscounts = null;
				}
			}
		},
		
		getDiscountSign: function(){
			var htmlCode = "";
			if( toBool( this.da.val("HASDISCOUNTS"), false) && this.options.showDiscountIndicator ) {
				htmlCode += '<div class="ui-corner-tr ui-corner-bl discount"><span>%</span></div>';
			}
			return htmlCode;
		},
		
		getNeuesBild: function(){
			var zeit = toStr(this.da.val("CreatedDate"));
			var neuezeit = zeit.toLocaleString();
			var oNeueZeit = neuezeit.split(".");
			var sMonat = '';
			if(parseInt(oNeueZeit[1],10)==1) sMonat = "January";
			if(parseInt(oNeueZeit[1],10)==2) sMonat = "February";
			if(parseInt(oNeueZeit[1],10)==3) sMonat = "March";
			if(parseInt(oNeueZeit[1],10)==4) sMonat = "April";
			if(parseInt(oNeueZeit[1],10)==5) sMonat = "May";
			if(parseInt(oNeueZeit[1],10)==6) sMonat = "June";
			if(parseInt(oNeueZeit[1],10)==7) sMonat = "July";
			if(parseInt(oNeueZeit[1],10)==8) sMonat = "August";
			if(parseInt(oNeueZeit[1],10)==9) sMonat = "September";
			if(parseInt(oNeueZeit[1],10)==10) sMonat = "October";
			if(parseInt(oNeueZeit[1],10)==11) sMonat = "November";
			if(parseInt(oNeueZeit[1],10)==12) sMonat = "December";
			neuezeit = sMonat + " " + oNeueZeit[0] + ", " + oNeueZeit[2];
			var end = new Date(neuezeit);

			d = new Date();
			count = Math.floor(d.getTime() - end.getTime());
			ablauf = Tage * 24 * 60 * 60 * 1000;
		
			var htmlCode = "", opts = this.options;
			if( count < ablauf ) {
			
			if (opts.displayTitlesOnTop) htmlCode += '<div style="position:absolute; left:2px; top:20px;"><img src="@image:neuesbild@" title="Neu"></div>';
			else htmlCode += '<div style="position:absolute; left:2px; top:2px;"><img src="@image:neuesbild@" title="Neu"></div>';
				
			}
			return htmlCode;
		},
		
		// gets datasheet table
		getDataSheet: function(){
			var htmlCode = "";
			
			htmlCode += '<div class="{0}" style="{1}">'.format(this.settings.plDatasheet.className, this.settings.plDatasheet.css);
			htmlCode += '<table>';
			htmlCode += this.getProps();
			htmlCode += this.getVariants();
			htmlCode += '</table>';
			htmlCode += '</div>';
			
			return htmlCode;
		},
		
		// gets several product data items
		getProps: function(){
			
			var htmlCode = "", 
				da = this.da,
				opts = this.options;
			
			htmlCode += this.getDataSheetItem( opts.showID , getLocalValue('lbl.product-id') , da.val("PRODUCTID") );
			htmlCode += this.getDataSheetItem( opts.showEAN , getLocalValue('lbl.product-ean') , da.val("EAN") );
			htmlCode += this.getDataSheetItem( opts.showWeight , getLocalValue('lbl.product-weight') , formatString(toFloat(da.val("WEIGHT"))) + ' ' + opts.defaultWeightUnit );
			htmlCode += this.getDataSheetItem( opts.showManufact , getLocalValue('lbl.manufacturer') , da.val("MANUFACTNAME") );
			
			if(opts.showDeliveryTime && da.val("DELIVERYTIMEPKID") > 0){
				
				htmlCode += '<tr>';
				htmlCode += '<td class="pl-itemcaption ellipsis">{0}</td>'.format(getLocalValue('lbl.delivery-time'));
				htmlCode += '<td class="pl-itemvalue"><span class="delivtime delivtime-{0}">'.format(toInt(da.val("DELIVERYTIMEPKID")));
				htmlCode += '<figure title="{0}">&nbsp;</figure>'.format(da.val("DELIVERYTIMENAME"));
				
				if(opts.showDeliveryTimeText) 
					htmlCode += '<span class="smaller">{0}</span>'.format(da.val("DELIVERYTIMENAME"));
				
				htmlCode += '</span></td>';
				htmlCode += '</tr>';
			}
			
			return htmlCode;
		},
		
		// gets default varaint
		getVariants: function(){
			var da = this.da,
				htmlCode = "",
				opts = this.options,
				arrCurrentVar;
			
			if(opts.showVariants && toBool( da.val('HASVARIANTS'), false) ){
				
				var arrVariants = [];
				arrVariants = toStr( da.val("SERIALIZEDVARSTRING") ).split("{EOL}");
				
				for(var i=0, length = arrVariants.length; i < length; i++ ){
					arrCurrentVar = arrVariants[i].split(':');
					htmlCode += this.getDataSheetItem( true , arrCurrentVar[0], arrCurrentVar[1] );
				}
			}
			
			return htmlCode;
		},
		
		getDataSheetItem: function(show, caption, value){
			if(show)
				return '<tr><td class="pl-itemcaption ellipsis">{0}</td><td class="pl-itemvalue ellipsis">{1}</td></tr>'.format( caption, _.isEmpty( toStr(value) ) ? "-" : value );
			else 
				return '';
		},
		
		getPriceBlock: function(small){
			
			var sPrice = "",
				opts = this.options,
				settings = this.settings,
				da = this.da,
				bHasDefaultDiscount = opts.hasDefaultDiscount,
				lDefaultDiscountType = opts.defaultDiscountType;
				
				var AddToBagOpts = {
					da:						da,
					showCaption:			false,
					showQtyField: 			small ? false : opts.showQtyInput,
					showAddToBag: 			(opts.showAddToBag && da.val("PRICINGCONFIGURATION") == 0 ),
					showDetail: 			(opts.showMore && this.getItemHref().length > 0),
					showQtyUnit: 			opts.showQtyUnit,
					displaySmallInfoButton:	false,
					displaySmallAddButton: 	true,
					isSmallAddCaption: 		small ? true : false
				}
				
				var basketPanelRenderer = new $.Renderers.BasketPanelRenderer( AddToBagOpts );
				
				
			if(opts.showPrice || opts.showAddToBag || opts.showMore){
				
				sPrice += '<div class="{0}" style="{1}">'.format(this.settings.plSales.className, this.settings.plSales.css);
				
				if( da.val("PRICINGCONFIGURATION") == 3 ){
					if( opts.showPrice ){
						sPrice += '<div class="pr-on-request">{0}</div>'.format(getLocalValue('lbl.price-on-demand'));
					}
				} else if(da.val("PRICINGCONFIGURATION") != 1){
					if(opts.showPrice) {
						
						if(toInt(da.val("BASECATEGORYDISCOUNT")) > 0 ||(bHasDefaultDiscount && lDefaultDiscountType != 2)) {
							
							if( !toBool(da.val("HIDELISTPRICE")) ) {
								//sPrice += '<div class="pr-pre-panel larger{0}">'.format(opts.colCount == 1 ? " quiet" : "");
								sPrice += '<div class="pr-pre-panel larger{0}">'.format(!settings.isGrid ? " quiet" : "");
								if(opts.showPricePrefix && toStr(da.val("PRICEPREFIX")).length > 0 && !small) {
									sPrice += '<span class="pr-pre-label">{0} </span>'.format(da.val("PRICEPREFIX"));
								}
								sPrice += '<span class="pr-pre-price"></span></div>';
							}
							
							sPrice += '<div class="pr-now-panel">';
							if(opts.showPricePrefix && toStr(da.val("DISCOUNTPREFIX")).length > 0 && !small) {
								sPrice += '<span class="pr-now-label bold">{0} </span>'.format(da.val("DISCOUNTPREFIX"));
							}
							
						} else {
							sPrice += '<div class="pr-now-panel">';
							if(opts.showPricePrefix && toStr(da.val("PRICEPREFIX")).length > 0 && !small){
								sPrice += '<span class="pr-now-label bold">' + da.val("PRICEPREFIX") + ' </span>';
							}
						}
						
						if(small){
							sPrice += '<span class="pr-now-price x-larger"></span>';
						} else {
							sPrice += '<span class="pr-now-price nice xx-larger"></span>';
						}
						
						sPrice += '</div>';
						
						if(opts.showSecCur && !small) {
							sPrice += '<div class="pr-sec-price quiet"></div>';
						}
						
						if( toInt(da.val("BASECATEGORYDISCOUNT")) > 0 || (bHasDefaultDiscount && lDefaultDiscountType != 2) && !small) {
							if(!toBool(da.val("HIDELISTPRICE")) && opts.showDifference) {
								sPrice += '<div><span class="pr-save-label bold">{0} </span><span class="pr-save-price"></span></div>'.format(getLocalValue('lbl.product-price-difference'));
							}
						}
						
						var dblShippingSurcharge = toFloat( da.val("SHIPPINGSURCHARGE") , 0 );
						var shippingCostsLink = getLocalValue('exp.ship-costs-info');
						var surchargeInfo = getLocalValue('exp.ship-surcharge-info');
						var sShippingSurcharge = ScriptLib.formatShipSurcharge(dblShippingSurcharge);
						
						
						if( (dblShippingSurcharge > 0) && surchargeInfo.length > 0 && small ){
							sPrice += '<div class="pr-transp-hint smaller x-quiet" data-value="{0}"></div>'.format( dblShippingSurcharge );
						}
						
						if(opts.showPriceSuffix && toStr(da.val("PRICESUFFIX")).length > 0){
							sPrice += '<div class="pr-now-suffix bold{0}">{1}</div>'.format(
								small ? "" : " larger",
								da.val("PRICESUFFIX")
							);
						}
						
						opts.showTax = !(toBool(da.val("NOTAX"), false));
						
						if((opts.showTax 
							|| toStr(shippingCostsLink).length > 0 
							|| dblShippingSurcharge > 0 
							|| (opts.showPriceBase && toBool(da.val("DISPLAYBASEPRICE"))))
							&& !small) {
							sPrice += '<div class="legal-hints smaller x-quiet">';
							
							if( opts.showTax && opts.showVATInfos ) {
								sPrice += '<div class="pr-vat-hint">{0} ({1}%)</div>'.format(
									opts.displayGrossPrice ? getLocalValue('lbl.vat-incl-info') : getLocalValue('lbl.vat-excl-info'),
									da.val("TAXPERCENT")  );
								
							}
							
							if((dblShippingSurcharge > 0) && surchargeInfo.length > 0){
								//sPrice += '<div class="pr-transp-hint">{0}</div>'.format( ScriptLib.formatShipSurcharge(dblShippingSurcharge) );
								sPrice += '<div class="pr-transp-hint" data-value="{0}"></div>'.format( dblShippingSurcharge );
							}
							if(toStr(shippingCostsLink).length > 0){
								sPrice += '<div class="pr-ship-hint">{0}</div>'.format( toStr( shippingCostsLink ) );
							}
							if(opts.showPriceBase && toBool(da.val("DISPLAYBASEPRICE")) && !(da.val("MUAMOUNT") == 1 && da.val("MUBASE") == 1)){
								sPrice += '<div class="pr-pangv"></div>';
							}
							
							sPrice += '</div>';
						}
					}
				} 
				
				if(!small) sPrice += '<div class="pl-controls">';
				sPrice += '<div class="pl-add-to-bag">{0}</div>'.format( basketPanelRenderer.getHtml() );
				if(!small) sPrice += '</div>';
				
				sPrice += '</div>';
			}
			
			return sPrice;
		},
		
		getMediaData: function(FKID, fromImageCache) {
			if(FKID == 0) return null;
			try	{
				var oMedia, data;
				if(!fromImageCache) oMedia = getMedia(FKID);
				else oMedia = imageCache.item(FKID);
				
				data = {
					src: oMedia.Src,
					width: oMedia.Width,
					height: oMedia.Height,
					fileName: oMedia.FileName,
					name: oMedia.Name,
					description: fromImageCache ? "" : oMedia.Description,
					altText: fromImageCache ? "" : oMedia.AltText,
					getSeoFriendlyName: function(fallback, skipDesc) {
						if(!skipDesc && this.description.length > 0){ return this.description; }
						else if(this.name.length > 0){ return this.name; }
						else if(fallback.length > 0){ return fallback; }
						else return this.fileName;
					}
				};
				
				return data;
			} catch(e){ return null; }
		},
		
		getMediaItem: function(productName) {
			var htmlCode = "",
				settings = this.settings,
				opts = this.options,
				da = this.da,
				objImg = settings.media.images[da.val('PKID')];
			
			htmlCode += '<figure class="{0}" style="{1}">'.format( settings.plFrameParent.className, settings.plFrameParent.css );
			
			if(objImg != null){
				var imgCss = "{0}width:{1}px;height:{2}px;".format( settings.plImg.css, objImg.width, objImg.height );
				
				if(opts.linkItemImages){
					htmlCode += '<a href="{0}" target="{1}"><img src="{2}" style="{3}" alt="{4}" title="{5}"></a>'.format(
						this.getItemHref(), 
						this.getItemTarget(), 
						objImg.src, imgCss, 
						_.encodeHtml(objImg.getSeoFriendlyName(productName, true)),
						_.encodeHtml(objImg.getSeoFriendlyName(productName, false))
					);
				} else {
					htmlCode += '<img src="{0}" style="{1}" alt="{2}" title="{2}">'.format( objImg.src, imgCss, _.encodeHtml(objImg.altText));
				}
			}
			
			htmlCode += '</figure>';
			
			return htmlCode;
		},
		
		// gets all parts of a bundled product
		getPartsList: function (table, showSeps){
			
			var da = this.da,
				htmlCode = "",
				opts = this.options;
			
			htmlCode += '<div class="pl-partslist">';
			
			if(opts.showItemPartsList && (toInt(da.val('PRODUCTTYPE')) == 1)){
				
				var rsPartsList = api.products.serializedBundleProducts(da.val("pkid"));
				
				if (rsPartsList != null){
					
					var sPartsListString = "";
					if(rsPartsList.RecordCount > 0){
						if(showSeps) htmlCode += '<hr>';
						if(table) sPartsListString += '<table cellpadding="0" cellspacing="0" width="100%">';
						if(toStr(rsPartsList("BUNDLETITLE")) != ''){
							if (table) 
								sPartsListString += '<th><td colspan="2" class="pl-partslist-header">{0}</td></th>'.format(rsPartsList("BUNDLETITLE"));
							else 
								sPartsListString += '<strong>{0}: </strong>'.format(rsPartsList("BUNDLETITLE"));
						};
					};
					
					while(!(rsPartsList.eof)){
						
						if(table) {
							sPartsListString += '<tr valign="top"><td align="right" class="pl-partslist-amount" nowrap="true">{0} x</td><td class="pl-partslist-item">{1}</td></tr>'.format(rsPartsList("PRODUCTQTY"), rsPartsList("NAME"));
						}
						else {
							sPartsListString += '<span>{0}x {1}{2} </span>'.format(
								rsPartsList("PRODUCTQTY"), 
								rsPartsList("NAME"), 
								rsPartsList.AbsolutePosition != rsPartsList.RecordCount ? ',' : '' );
						}
						rsPartsList.movenext;
					};
					
					if(rsPartsList.RecordCount > 0){
						if(table) sPartsListString += '</table>';
						if(showSeps) sPartsListString += '<hr>';
					};
					
					htmlCode += sPartsListString;
				};
			}
			
			htmlCode += '</div>';
			
			return htmlCode;
		},
		
		// sets thumbnail attribute that's necessary to display a thumbnail in minibasket and basket module
		setThumbnailAttribute: function(thumbMRef) {
			
			var objMedia, path;
			if(thumbMRef > 0){
				objMedia = getMedia(thumbMRef);
				//objMedia = this.settings.media.images[this.da.val('PKID')];
				path = objMedia.FullPath;
				var urlPos = objMedia.src.indexOf('http://');
				
				if( !toBool(parameters("app-design-mode")) && !toBool(parameters("app-preview-mode")) ){
					
					if(urlPos != -1){
						path = '"' + objMedia.src.substr(urlPos) + '"';
					} 
					else {
						path = '"' + ResolveURLFromRoot(objMedia.src) + '"';
					}
					
				} else {
					if(urlPos != -1){
						path = '"' + objMedia.src.substr(urlPos) + '"';
					} 
					else {
						path = '"{0}"'.format(path);
					}
				}
				
			} else {
				objMedia = imageCache.item("img_nopic_small");
				path = objMedia.src;
				
				if( !toBool(parameters("app-design-mode")) && !toBool(parameters("app-preview-mode")) ){
					//path = '"{0}"'.format( (objMedia.src).substr(2) );
					path = '"/images/' + objMedia.FileName + '"';
				} else {
					path = '"{0}"'.format(path);
				}
			}
			
			
			if(path.substring(0, 1) == ".") 
				path = path.substring(1);
			
			return "SMProduct.setAttribute(_SMAThumb, {0});".format( path.replace(/\\/g, "/") );
		},
		
		// initialises product
		getProductJSInitCode: function(){
			
			var da = this.da,
				sData = "", 
				lPkid = toInt(da.val("PKID")), 
				sMediaFileSrc = "",
				bNoInternalDetail = (toBool(da.val("NODETAILPAGE")) && !toBool(da.val("ISSMARTLINK"))) || (toBool(da.val("ISSMARTLINK")) && toInt(da.val("SMARTLINKTYPE"))==99);
			
			sData += '<script type="text/javascript">SMProduct = SMProductList[' + lPkid + '] = SMShop.createProduct();';
			sData += 'SMProduct.set("'
						+ _.encodeUri(da.val("PRODUCTID")) + '",'
						+ lPkid + ','
						+ da.val("TAXKEY") + ','
						+ da.val("NOTAX") + ','
						+ ScriptLib.formatCurrency( parseFloat(da.val("SELLINGPRICE")) ) + ','
						+ parseFloat(da.val("BASECATEGORYDISCOUNT")) + ','
						+ parseFloat(da.val("WEIGHT")) + ','
						+ '"' + _.encodeUri(da.val("NAME")) + '",'
						+ '"' + _.encodeUri(da.val("DESCRIPTION")) + '",'
						+ '"' + sMediaFileSrc + '",'
						+ parseFloat(da.val("MINORDERQTY")) + ','
						+ parseFloat(da.val("MAXORDERQTY")) + ','
						+ toInt(da.val("ORDERQTYSTEP")) + ','
						+ toInt(da.val("OQTYPE")) + ','
						+ toFloat(da.val("OQDEFVALUE")) + ','
						+ toInt(da.val("OQDDOPTIONSCOUNT")) + ','
						+ '"' + da.val("QTYUNIT") + '",'
						+ da.val("SHIPPINGSURCHARGE") + ","
						+ (bNoInternalDetail ? "location.href" : ScriptLib.getRelativePageURLFromRoot(lPkid, 2)) + ","
						+ da.val("DELIVERYTIMEFKID") + ","
						+ '"' + toStr(da.val("EAN")) + '",'
						+ '"' + _.encodeUri(toStr(da.val("MANUFACTNAME"))) + '", '
						+ (toBool(da.val("DISPLAYBASEPRICE")) ? toFloat(da.val("MUAMOUNT"), 1): 1) + ","
						+ (toBool(da.val("DISPLAYBASEPRICE")) ? toFloat(da.val("MUBASE"), 1): 1) + ","
						+ (toBool(da.val("DISPLAYBASEPRICE")) ? "'" + toStr(da.val("MEASUREUNIT") + "'", ""): "''"),
						+ da.val("PRODUCTTYPE")						
						+ ");";
			
			sData += this.setThumbnailAttribute(toInt(da.val("THUMBMREF")));
			
			if(toBool(da.val("HASVARIANTS"))){
				/* for all types of variants */
				sData += ScriptLib.SMOMSetVariantHeaders(lPkid);
				
				if(toInt(da.val("VARPKID")) > 0){
					/* for complex variants only */
					sData += ScriptLib.SMOMSetVariantValues(lPkid, true, toInt(da.val("VARPKID"))); /* display default variant only */
				} else {
					/* for simple variants only */
					sData += ScriptLib.SMOMSetDefaultSimpleVariant(da.storage); /* display default variant only */
				};
			};
			
			bHasDefaultDiscount = false;
			if(toBool(da.val("HASDISCOUNTS"),false)){
				
				var rsDiscounts = api.products.serializedQuantityDiscounts(lPkid,false);
				if(rsDiscounts!=null){
					while(!(rsDiscounts.eof)){
						sData += "SMProduct.discounts.add(" + rsDiscounts("fromAmount") + "," + rsDiscounts("discountType") + "," + rsDiscounts("discountValue") + ",\"" + toStr(rsDiscounts("name")) + "\");";
						if(parseInt(rsDiscounts("fromAmount"))<=parseInt(da.val("MINORDERQTY")))
						{
							bHasDefaultDiscount = true;
							lDefaultDiscountType = parseInt(rsDiscounts("discountType"));
						}
						rsDiscounts.movenext;
					};
				};
				rsDiscounts.close;
				rsDiscounts = null;
			};
			
			sData += "SMProduct.update();</script>";
			return sData; 
		},
		
		getItemHref: function(){
			
			var da = this.da;
			
			if(toBool(da.val("ISSMARTLINK"))){
				return toStr( da.val("SMARTLINKREF") );
			}
			else if( !toBool( da.val("NODETAILPAGE") ) ){
				return "product:" + da.val("PKID");
			}
			return "";
		},
		
		getItemTarget: function(){
			
			var da = this.da;
			
			if(toBool(da.val("ISSMARTLINK")))
				return toStr(da.val("SMARTLINKTARGET"));
			else 
				return "";
		},
		
		render: function( da ) {
			output( this.getHtml( da ) );
		}
	}
})();
